package re.jimmitry.apps974.furious;
import re.jimmitry.apps974.furious.*;
import re.jimmitry.apps974.fursys.*;
import re.jimmitry.apps974.wsfurious.*;
import re.jimmitry.apps974.wsfurious.xsd.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.net.SocketTimeoutException;

public class GeoLocation {
  public String IP;
  public String Country;
  public String Region;
  public String City;
  public String Latitude;
  public String Longitude;

  public GeoLocation()
  {
    this.IP = "Unknown";
    this.Country = "Unknown";
    this.Region = "Unknown";
    this.City = "Unknown";
    this.Latitude = "Unknown";
    this.Longitude = "Unknown";
  }
  public void GetGeoLocationByIP(String IPAddress)
  {
    try
    {
      String generate_URL = "http://www.geoplugin.net/xml.gp?ip=" + IPAddress;
      this.IP = IPAddress;
      URL data = new URL(generate_URL);
      URLConnection yc = data.openConnection();
      yc.setConnectTimeout(Integer.parseInt(FurPARAM.getDBSConnectorParam("GEOLOC_CONNECT_TIMEOUT").DATA));
      yc.setReadTimeout(Integer.parseInt(FurPARAM.getDBSConnectorParam("GEOLOC_READ_TIMEOUT").DATA));
      yc.connect();
      BufferedReader in = new BufferedReader(new InputStreamReader(yc.getInputStream()));
      String inputLine;
      while ((inputLine = in.readLine()) != null)
      {
        if (inputLine.contains("<geoplugin_city>"))
        {
          int conStart = inputLine.indexOf("<geoplugin_city>");
          int conEnd = inputLine.indexOf("</geoplugin_city>", conStart + 16);
          this.City = inputLine.substring(conStart + 16, conEnd);
        }
        if (inputLine.contains("<geoplugin_region>"))
        {
          int conStart = inputLine.indexOf("<geoplugin_region>");
          int conEnd = inputLine.indexOf("</geoplugin_region>", conStart + 16);
          this.Region = inputLine.substring(conStart + 18, conEnd);
        }
        if (inputLine.contains("<geoplugin_countryName>"))
        {
          int conStart = inputLine.indexOf("<geoplugin_countryName>");
          int conEnd = inputLine.indexOf("</geoplugin_countryName>", conStart + 9);
          this.Country = inputLine.substring(conStart + 23, conEnd);
        }
        if (inputLine.contains("<geoplugin_latitude>"))
        {
          int conStart = inputLine.indexOf("<geoplugin_latitude>");
          int conEnd = inputLine.indexOf("</geoplugin_latitude>", conStart + 9);
          this.Latitude = inputLine.substring(conStart + 20, conEnd);
        }
        if (inputLine.contains("<geoplugin_longitude>"))
        {
          int conStart = inputLine.indexOf("<geoplugin_longitude>");
          int conEnd = inputLine.indexOf("</geoplugin_longitude>", conStart + 9);
          this.Longitude = inputLine.substring(conStart + 21, conEnd);
        }
      }
    }
    catch (SocketTimeoutException f)
    {
      this.Country = "Timeout";
      this.Region = "Timeout";
      this.City = "Timeout";
      this.Latitude = "Timeout";
      this.Longitude = "Timeout";
    }
    catch (Exception e)
    {
      this.Country = "Error";
      this.Region = "Error";
      this.City = "Error";
      this.Latitude = "Error";
      this.Longitude = "Error";
    }
    

    this.Country = this.Country.replace("&#257;", "a");
    this.Region = this.Region.replace("&#257;", "a");
    this.City = this.City.replace("&#257;", "a");
  }
}
